package com.steerinfo.meterwork.meterworkaddweight.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkaddweight.model.MeterWorkAddWeight;
import com.steerinfo.meterwork.meterworkaddweight.service.IMeterWorkAddWeightService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkAddWeight RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-09-16 08:14
 * 类描述
 * 修订历史：
 * 日期：2020-09-16
 * 作者：generator
 * 参考：
 * 描述：MeterWorkAddWeight RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkaddweights")
@Api(value = "/${api.version}/meterworkcarchecks", tags = "附加重量实绩 - MeterWorkCarCheckController")
public class MeterWorkAddWeightController extends BaseRESTfulController {

    @Autowired
    IMeterWorkAddWeightService meterWorkAddWeightService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkaddweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkAddWeight> list = meterWorkAddWeightService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkaddweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkAddWeight> list = meterWorkAddWeightService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkAddWeight对象创建")
    @ApiImplicitParam(name = "meterWorkAddWeight", value = "详细实体meterWorkAddWeight", required = true, dataType = "MeterWorkAddWeight")
    //@RequiresPermissions("meterworkaddweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkAddWeight model) {
        try {
            MeterWorkAddWeight meterWorkAddWeight = meterWorkAddWeightService.add(model);
            return success(meterWorkAddWeight);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkaddweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkAddWeight meterWorkAddWeight = meterWorkAddWeightService.getById(id);
            return success(meterWorkAddWeight);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkAddWeight信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkAddWeight", value = "详细实体meterWorkAddWeight", required = true, dataType = "MeterWorkAddWeight")
    })
    //@RequiresPermissions("meterworkaddweight:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkAddWeight model) {
        try {
            model.setId(id);
            MeterWorkAddWeight meterWorkAddWeight = meterWorkAddWeightService.modify(model);
            return success(meterWorkAddWeight);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkaddweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkAddWeightService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "新增数据", notes = "根据MeterWorkAddWeight对象创建")
    @ApiImplicitParam(name = "MeterWorkAddWeight", value = "详细实体MeterWorkAddWeight", required = true, dataType = "MeterWorkAddWeight")
    //@RequiresPermissions("meterworkcaractualfirst:create")
    @PostMapping(value = "/add")
    public RESTfulResult chechandadd(@RequestBody MeterWorkAddWeight model) {
        RESTfulResult rm = failed();
        try {
            String no = meterWorkAddWeightService.checkhandadd(model);
            if (no != null) {
                return success(no);
            } else {
                return failed("新增失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "多条删除", notes = "根据url的参数来指定删除多个对象")
    @PostMapping(value = "/delete")
    public RESTfulResult deleteList(@RequestBody List<MeterWorkAddWeight> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkAddWeightService.deleteList(models);
            if (num > 0) {
                return success("成功删除" + num + "条信息");
            } else {
                return failed("删除失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkAddWeight对象创建")
    @ApiImplicitParam(name = "meterWorkAddWeight", value = "详细实体meterWorkAddWeight", required = true, dataType = "MeterWorkAddWeight")
    //@RequiresPermissions("meterworkaddweight:create")
    @PostMapping(value = "/doAddWf")
    public RESTfulResult doAddWf(@ModelAttribute MeterWorkAddWeight model) {
        try {
            MeterWorkAddWeight meterWorkAddWeight = meterWorkAddWeightService.add(model);
            return success(meterWorkAddWeight);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
